import React, { MutableRefObject } from 'react';
import { ReactNode } from 'react';
import { FormInstance, FormProps } from 'antd';
interface ColumnProps {
    title: string;
    dataIndex: string;
    key?: string | number;
    width?: number;
    ellipsis?: Boolean;
    showTitle?: Boolean;
    hideInSearch?: boolean;
    search?: {
        transform?: (value: any) => Record<string, any>;
    };
    valueType?: 'text' | 'select' | 'treeSelect' | 'date' | 'dateTime' | 'dateMonth' | 'dateYear' | 'dateRange' | 'dateTimeRange' | 'checkbox' | 'radio' | 'radioButton' | 'switch' | 'digit' | 'image';
    valueEnum?: Record<string, any>;
    options?: Record<string, any>[];
    fieldProps?: Record<string, any>;
    formItemProps?: Record<string, any>;
    order?: number;
    colSize?: number;
    initialValue?: any;
    request?: () => Promise<any>;
    render?: (text: string, record: Record<string, any>, index: number) => ReactNode;
}
declare type defaultColConfig = {
    xs: 24;
    sm: 24;
    md: 12;
    lg: 12;
    xl: 8;
    xxl: 6;
};
interface Isearch {
    labelWidth?: number | 'auto';
    span?: number | defaultColConfig;
    filterType?: 'query' | 'light';
    searchText?: string;
    resetText?: string;
    submitText?: string;
    hideSubmit?: boolean;
    transform?: (value: any) => any;
    optionRender?: ((searchConfig: any, formProps: any, dom: any) => ReactNode[]) | false;
}
export interface WFormProps extends FormProps {
    className?: string;
    style?: React.CSSProperties;
    columns: ColumnProps[];
    onSubmit?: (params: Record<string, any>) => void;
    onReset?: () => void;
    formRef?: MutableRefObject<FormInstance>;
    search?: Isearch | false;
}
declare const _default: React.ForwardRefExoticComponent<WFormProps & React.RefAttributes<unknown>>;
export default _default;
